/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlets;


import hibernate.Passwordstore;
import hibernate.util.HibernateUtil;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.security.NoSuchAlgorithmException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.hibernate.Session;
import util.ConvertPassword;

/**
 *
 * @author Ani
 */
@WebServlet(name="Login", urlPatterns={"/login"})
public class Login extends HttpServlet {
    private Session hibernateSession;
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            request.setCharacterEncoding("UTF-8");
            request.getSession().setAttribute("alreadyTried", true);
            hibernateSession = HibernateUtil.getSessionFactory().openSession();
            hibernateSession.beginTransaction();

            Passwordstore pw = (Passwordstore) hibernateSession.get(Passwordstore.class,
                    request.getParameter("username"));

            if (pw!=null && pw.getPassword().equals(ConvertPassword.
                    convertPassword(request.getParameter("password")))){
                request.getSession().setAttribute("loggedUser", pw.getUserdata());
            }
            hibernateSession.close();

            response.sendRedirect("index.jsp");

        } catch (NoSuchAlgorithmException ex) {

        } catch (UnsupportedEncodingException ex) {

        } finally { 
            out.close();
        }


    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
